#include "KMotionDef.h"
#define TMP 55 // which spare persist to use to transfer data
#include "KflopToKMotionCNCFunctions.c"

#define SPINDLEAXIS 4
#define SpindlePosition 36
#define SpindleHoming 37
#define SpindleHomed 43
#define STATEVAR 98
#define CNTS_PER_DEG 5000

main()
{

	WaitNextTimeSlice();

	SetBitDirection(SpindlePosition,1);
	SetBitDirection(SpindleHoming,1);
	SetBitDirection(SpindleHomed,0);
	
	
	double PositionToGo;
	double PositionToGotTol;
	double PulsePerRotation;
	double StepBySlot;
	double SpindleTurretPos;

	
	double ZTurret;
	double ZSafe;
	double ZOffTurret;
	double steppermmZ;
	
	
	int ToolID; 
	int NewID;
	int NewSlot;
	int ActualSlot; 

	
	ZTurret = 153; 				//Position of Z for turret rotation
	ZOffTurret = 137; 			// Position of Z to realign tool after turret rotation
	ZSafe = 0; 				//Position of Z before engaging tool change area

	
	NewSlot=persist.UserData[9]; 		// Number of slot to load
	ActualSlot = persist.UserData[6]; 	//Number of the slot actually loaded
	StepBySlot = 2425; 			// Number of steps to VFD to move by 1 slot the turret 2400
		
	SpindleTurretPos=-102;  			//Position of Spindle to engage Turret
	PositionToGotTol=5;
	steppermmZ = 250;
	
	
	int NoiseFilter;
	int NoiseCounter;
	double filter;
	int filterqty;
	int StopLoop;
	double acc;
	
	filter = 0.001;
	filterqty = 200;
	
	StopLoop = 0;
	
	
	if (NewSlot == ActualSlot)
	{
		while (!CheckDone(3)); 
		return (0);
	}

//--------Moving to ZSafe and Home Spindle-----------------//

	ClearBit(SpindlePosition); 		// clear Position mode of the spindle
	SetBit(SpindleHoming);			// Set Spindle to Homing mode
	
	MoveAtVel(2, ZSafe*steppermmZ, 25000/60*steppermmZ); // Move to ZSafe position
	Jog(SPINDLEAXIS,0); 			//while (!CheckDone(SPINDLEAXIS));
	
	//Delay_sec(0.1);

	printf("Jogging Spindle Stop\n");
	persist.UserData[STATEVAR] = 0;		// remember we are Off
	{
	}
	
	while (!StopLoop) { // wait for SpindleHomed to go TRUE for filterqty*filter
		StopLoop = 0;	
		if(ReadBit(SpindleHomed)) {	
			NoiseFilter = 0;
			NoiseCounter = 0;	
			while(NoiseCounter < filterqty) {
				Delay_sec(filter);
				NoiseCounter++;
				if(ReadBit(SpindleHomed)){
					NoiseFilter++;
				}
			}
			if (NoiseFilter==filterqty) {
				StopLoop = 1;
			}
		}
	}
	
	StopLoop = 0;
	
	Delay_sec(0.1);
	ClearBit(SpindleHoming);		// clear Homing mode of the spindle
	ch4->Position=0;
    	EnableAxis(SPINDLEAXIS);
	Delay_sec(0.01);
	SetBit(SpindlePosition);		// Set Spindle to Position mode

	
	while (ch2->Dest<(ZSafe-15)*steppermmZ);
	
	
//------------Go to turret rotation position---------------//

	ch2->SoftLimitPos=9999990;	
	MoveAtVel(2, ZTurret*steppermmZ, 4000/60*steppermmZ);// Move Z to turret rotation position
	while (ch2->Dest<(ZOffTurret-80)*steppermmZ) ; // loop until Z is 70mm under Offturret
	MoveAtVel(2, ZTurret*steppermmZ, 15000/60*steppermmZ);// Move Z to turret rotation position
	
	while (ch2->Dest<(ZOffTurret-50)*steppermmZ) ; // loop until Z is 50mm under Offturret
	MoveAtVel(4, SpindleTurretPos, 10000); 	// Move Spindle to turret rotation position
	
	while (ch2->Dest<(ZOffTurret-15)*steppermmZ) ; // loop until Z is 70mm under Offturret
	MoveAtVel(2, ZTurret*steppermmZ, 5000/60*steppermmZ);// Move Z to turret rotation positio
	while (!CheckDone(2)); 			// loop until motion completes
	

//-----------------Rotate to NewSlot-----------------------//	
	
	ch4->Accel=25000; //100000
	
	if (-5 <= (NewSlot-ActualSlot) && (NewSlot-ActualSlot) <= 5)
	{
		PositionToGo = (NewSlot-ActualSlot)*StepBySlot+SpindleTurretPos;
	}
	else
	{
		if (ActualSlot > NewSlot)
		{
			PositionToGo = (10-(ActualSlot-NewSlot))*StepBySlot+SpindleTurretPos;
		}
		else
		{
			PositionToGo = -(10+(ActualSlot-NewSlot))*StepBySlot+SpindleTurretPos;
		}
	}
	
	ch4->Dest=0;
	ch4->Position=0;
	MoveAtVel(4, PositionToGo, 10000); 	// Rotates to NewSlot
	while (!CheckDone(4)); 			// loop until motion completes
	while(!(PositionToGo - PositionToGotTol < Pos(4)) && !(Pos(4) <PositionToGo + PositionToGotTol));
	Delay_sec(0.5);
	persist.UserData[6]=NewSlot; 		//update the persist 6
	
	ch4->Accel=500000; //100000	
	
	char s[100];
	//int Units, TWORD, HWORD, DWORD;	
	//GetMiscSettings(&Units, &TWORD, &HWORD, &DWORD);
	sprintf(s,"G43 H%d",persist.UserData[9]);
	ToolID=sprintf(s,"G43 H%d",persist.UserData[9]);
	//printf(s);
	//MDI(s);
	

//-----------Go to ZSafe and reposition spindle------------//

	MoveAtVel(2, ZSafe*steppermmZ, 15000/60*steppermmZ); // Move to Offturret rotation position
	while (ch2->Dest>(ZOffTurret-20)*steppermmZ) ; // loop until Z is Offturret
	ClearBit(SpindlePosition); 		// clear Position mode of the spindle
	SetBit(SpindleHoming);			// Set Spindle to Homing mode
	while (ch2->Dest>(ZOffTurret-25)*steppermmZ) ; // loop until Z is Offturret
	MoveAtVel(2, ZSafe*steppermmZ, 5000/60*steppermmZ); // Move to Offturret rotation position

	ClearBit(SpindlePosition); 		// clear Position mode of the spindle
	SetBit(SpindleHoming);			// Set Spindle to Homing mode
	
	
//-------------Wait until end of movement------------------//

	while (!CheckDone(2)) ; 		// loop until motion completes
	ch2->SoftLimitPos=50;
	ch4->Dest=0;
	ch4->Position=0;
	while (!CheckDone(3)); 
	//MDI(ToolID);
	
	
}
