#include "KMotionDef.h"

#define SPINDLEAXIS 4
#define FACTOR (10000/60.0) //1000 counts/sec / 100 counts/rev = 1 RPS = 60 RPM
#define SPEEDVAR 99
#define STATEVAR 98
#define KMVAR 1
#define SpindlePosition 36
#define SpindleHoming 37
#define SpindleHomed 43


// save in user variable STATEVAR whether it was off, CW, or CCW (0,1,-1)

main()
{

	SetBitDirection(SpindlePosition,1);
	SetBitDirection(SpindleHoming,1);
	SetBitDirection(SpindleHomed,0);

	int NoiseFilter;
	int NoiseCounter;
	double filter;
	int filterqty;
	int StopLoop;
	double acc;
	
	filter = 0.001;
	filterqty = 200;
	
	StopLoop = 0;
	

	Jog(SPINDLEAXIS,0);
	//while (!CheckDone(SPINDLEAXIS));
	ClearBit(SpindlePosition); 		// clear Position mode of the spindle
	//Delay_sec(0.1);
	SetBit(SpindleHoming);			// Set Spindle to Homing mode

	
	printf("Jogging Spindle Stop\n");
	persist.UserData[STATEVAR] = 0;		// remember we are Off
	{
	}
	
	while (!StopLoop) { // wait for SpindleHomed to go TRUE for filterqty*filter
		StopLoop = 0;	
		if(ReadBit(SpindleHomed)) {	
			NoiseFilter = 0;
			NoiseCounter = 0;	
			while(NoiseCounter < filterqty) {
				Delay_sec(filter);
				NoiseCounter++;
				if(ReadBit(SpindleHomed)){
					NoiseFilter++;
				}
			}
			if (NoiseFilter==filterqty) {
				StopLoop = 1;
			}
		}
	}
	
	StopLoop = 0;
	
	Delay_sec(0.1);
	ClearBit(SpindleHoming);		// clear Homing mode of the spindle
	ch4->Position=0;
    EnableAxis(SPINDLEAXIS);
    Zero(SPINDLEAXIS);
	Delay_sec(0.01);
	SetBit(SpindlePosition);		// Set Spindle to Position mode
	
}

