#include "KMotionDef.h"

#define SPINDLEAXIS 4
#define FACTOR (10000/60.0) //1000 counts/sec / 100 counts/rev = 1 RPS = 60 RPM
#define SPEEDVAR 99
#define STATEVAR 98
#define KMVAR 1
#define SpindlePosition 36
#define SpindleHoming 37
#define SpindleHomed 43


// desired speed is passed from KMotionCNC in variable KMVAR
// save in user variable STATEVAR whether it was off, CW, or CCW (0,1,-1)
// save in user variable SPEEDVAR the last desired speed

main()
{

	SetBitDirection(SpindlePosition,1);
	SetBitDirection(SpindleHoming,1);
	SetBitDirection(SpindleHomed,0);
		
	ClearBit(SpindleHoming);		// clear Homing mode of the spindle
	Delay_sec(0.1);
	SetBit(SpindlePosition);		// Set Spindle to Position mode	
	
	
	float speed = *(float *)&persist.UserData[SPEEDVAR];  // value stored is actually a float 
	float LastState = persist.UserData[STATEVAR];  // get last state 
	
	if (LastState==1)  
	{
		Jog(SPINDLEAXIS,0);
		while (!CheckDone(SPINDLEAXIS)) ;
	}
	
	// spindle is already on, so ramp to new speed
	Jog(SPINDLEAXIS,speed * FACTOR);
	printf("Jogging Spindle %f counts/sec\n",speed * FACTOR);
	
	persist.UserData[STATEVAR] = -1;  // remember we are CCW
}

